﻿class net.wargaming.ingame.damagePanel.EntityItem extends gfx.core.UIComponent
{
    var initialized, repairMc, hitTest, gotoAndPlay, __get__toolTipData, onRollOver, onRollOut, onRelease, onReleaseOutside, onPress, __get__entityName, __set__toolTipData;
    function EntityItem()
    {
        super();
    } // End of the function
    function invalidateData(entityName, newState)
    {
        if (!initialized)
        {
            invalidateSavedDataName = entityName;
            invalidateSavedDataState = newState;
            return;
        } // end if
        if (newState == "destroyed")
        {
            repairMc.setState("normal", false);
        } // end if
        if (m_entityName != entityName)
        {
            return;
        } // end if
        if (m_state != newState)
        {
            if (repairMc && newState == "normal" && m_state != newState)
            {
                repairMc.setState("repairedFull", true);
            } // end if
            if (newState == "repaired")
            {
                repairMc.setState("repaired", true);
            } // end if
            m_state = newState;
            if (this.hitTest(_root._xmouse, _root._ymouse, true))
            {
                net.wargaming.managers.ToolTipManager.__get__instance().setContent(this._getToolTipData());
            } // end if
            this.gotoAndPlay(m_state);
        } // end if
    } // End of the function
    function startRepairProgress(entityName, progress, secondsLeft)
    {
        if (repairMc)
        {
            repairMc.startRepairProgress(entityName, progress, secondsLeft);
        } // end if
    } // End of the function
    function removeTooltip()
    {
        this._destroyToolTip();
    } // End of the function
    function get toolTipData()
    {
        return (m_toolTipData);
    } // End of the function
    function set toolTipData(value)
    {
        m_toolTipData = value;
        null;
        //return (this.toolTipData());
        null;
    } // End of the function
    function get entityName()
    {
        return (m_entityName);
    } // End of the function
    function configUI()
    {
        onRollOver = handleMouseRollOver;
        onRollOut = handleMouseRollOut;
        onRelease = _destroyToolTip;
        onReleaseOutside = _destroyToolTip;
        super.configUI();
        onPress = handleMousePress;
        if (invalidateSavedDataState != "")
        {
            this.invalidateData(invalidateSavedDataName, invalidateSavedDataState);
            invalidateSavedDataName = "";
            invalidateSavedDataState = "";
        } // end if
    } // End of the function
    function _createToolTip()
    {
        if (m_toolTipData && _root.g_cursorVisible)
        {
            net.wargaming.managers.ToolTipManager.__get__instance().show(this._getToolTipData(), m_toolTipInitProps);
        } // end if
    } // End of the function
    function _destroyToolTip()
    {
        net.wargaming.managers.ToolTipManager.__get__instance().hide();
    } // End of the function
    function _getToolTipData()
    {
        if (m_state == "repaired")
        {
            m_state = "critical";
        } // end if
        return (m_toolTipData + "/" + m_state);
    } // End of the function
    function handleDamageIconClick(entityName, state)
    {
    } // End of the function
    function handleMousePress(mouseIndex, button)
    {
        this._destroyToolTip();
        if (m_entityName.length > 0)
        {
            this.handleDamageIconClick(m_entityName, m_state);
        } // end if
    } // End of the function
    function handleMouseRollOver(mouseIndex, nestingIdx)
    {
        this._createToolTip();
    } // End of the function
    function handleMouseRollOut(mouseIndex, nestingIdx)
    {
        this._destroyToolTip();
    } // End of the function
    var invalidateSavedDataName = "";
    var invalidateSavedDataState = "";
    var m_toolTipInitProps = {_delay: 0.500000, _leftMargin: 10, _rightMargin: 10, _topMargin: 10, _bottomMargin: 10};
    var m_state = "normal";
    var m_entityName = "";
    var m_toolTipData = "";
} // End of Class
