﻿class net.wargaming.ingame.damagePanel.Panel extends MovieClip
{
    var componentsContainer, entityMapping, savedEntityMapping, LogFx, TxtLog1, TxtLog2, TxtLog3, TxtLog4, TxtLog5, TxtLog6, TxtLog7, TxtLog8, TxtLog9, TxtLog10, __get__deviceNames;
    function Panel()
    {
        super();
        componentsContainer.tankIndicator.owner = this;
    } // End of the function
    function get deviceNames()
    {
        return (_deviceNames);
    } // End of the function
    function setIconsLayout()
    {
        componentsContainer.turretRotator._visible = Boolean(arguments.pop());
        this.createCrewRenderers(arguments.slice());
    } // End of the function
    function updateState(entityName, state)
    {
        var symbolPath = this.entityMapping[entityName];
        if (symbolPath != undefined)
        {
            var result = eval("this.componentsContainer." + symbolPath);
            result.invalidateData(entityName, state);
            result.repairMc.repairTime.text = "";
        }
        else
        {
            this.savedEntityMapping[entityName] = state;
        } // end else if
        this.componentsContainer.tankIndicator.updateState(entityName, state);
    } // End of the function
    function updateAllStates(state)
    {
        var _loc3 = _deviceNames.length;
        for (var _loc2 = 0; _loc2 < _loc3; ++_loc2)
        {
            this.updateState(_deviceNames[_loc2], state);
        } // end of for
    } // End of the function
    function setMaxHealth(max)
    {
        _maxHealth = max;
        if (_LogNb == 1)
        {
            _LogHelth = _maxHealth;
        } // end if
    } // End of the function
    function updateHealth(current)
    {
        current = Math.max(current, 0);
        var _loc4 = current / _maxHealth;
        componentsContainer.healthBar.setProgress(_loc4, 1);
        componentsContainer.healthField.text = current.toString() + "/" + _maxHealth.toString();
        var _loc3 = _LogHelth - current;
        _LogHelth = current;
        if (_loc3 > 0 && isLogEnabled)
        {
            this.AddToLogFlds((_LogNb < 10 ? ("") : ("")) + "-" + _loc3.toString()) + "\n";
            ++_LogNb;
            LogFx.gotoAndPlay(2);
        } // end if
        if (current == 0 || isVehicleDestroyed)
        {
            isLogEnabled = false;
        } // end if
    } // End of the function
    function updateModuleRepair(entityName, progress, secondsLeft)
    {
        var symbolPath = this.entityMapping[entityName];
        if (symbolPath != undefined)
        {
            var result = eval("this.componentsContainer." + symbolPath);
            result.startRepairProgress(entityName, progress, secondsLeft);
            result.repairMc.repairTime.text = int(Math.round(secondsLeft));
        } // end if
    } // End of the function
    function setPlayerInfo(playerName, vehicleTypeName)
    {
        componentsContainer.pNameField.text = playerName;
        componentsContainer.vTypeNameField.text = vehicleTypeName;
    } // End of the function
    function setCruiseMode(mode)
    {
        var _loc3 = cruiseCtrlModeTable[mode >= 0 ? (mode) : (Math.abs(mode) + 3)];
        componentsContainer.cruiseCtrl.gotoAndStop(_loc3);
    } // End of the function
    function updateSpeed(speed)
    {
        componentsContainer.cruiseCtrl.speed.text = speed.toString() + " km/h";
    } // End of the function
    function reset()
    {
        this.createMapping();
        this.updateAllStates("normal");
        this.removeCrewRenderers();
        componentsContainer.fireMessage._visible = false;
        componentsContainer.fireIcon.gotoAndPlay("normal");
        componentsContainer.lockChassisIcon._visible = false;
        this.setCruiseMode(0);
        this.updateSpeed(0);
        componentsContainer.tankIndicator.reset();
    } // End of the function
    function onCrewDeactivated()
    {
        this.setCruiseMode(0);
        this.updateSpeed(0);
        var _loc2;
        for (var _loc3 = 0; _loc3 < crewRenderers.length; ++_loc3)
        {
            _loc2 = crewRenderers[_loc3];
            _loc2.invalidateData(_loc2.entityName ? (_loc2.entityName) : (_loc2._name), "destroyed");
        } // end of for
    } // End of the function
    function onVehicleDestroyed()
    {
        this.setCruiseMode(0);
        this.updateSpeed(0);
        this.updateAllStates("destroyed");
        componentsContainer.tankIndicator.onVehicleDestroyed();
    } // End of the function
    function onFireInVehicle(bool)
    {
        componentsContainer.fireMessage._visible = bool;
        componentsContainer.fireIcon.gotoAndPlay(bool ? ("critical") : ("repaired"));
    } // End of the function
    function onVehicleAutorotationEnabled(bool)
    {
        componentsContainer.lockChassisIcon._visible = !bool;
    } // End of the function
    function onLoad()
    {
        this.reset();
        _LogHelth = 0;
        _LogNb = 1;
        this.ClearLogFlds();
    } // End of the function
    function createMapping()
    {
        entityMapping = {engine: "engine", ammoBay: "ammoBay", gun: "gun", turretRotator: "turretRotator", leftTrack: "chassis", rightTrack: "chassis", surveyingDevice: "surveyingDevice", radio: "radio", fuelTank: "fuelTank"};
        savedEntityMapping = {};
    } // End of the function
    function createCrewRenderers(names)
    {
        var _loc6 = names.length;
        var _loc4 = new Object();
        var _loc2;
        componentsContainer.crewContainer._x = 284 - _loc6 * (_crewItemWidth + _crewItemMargin) >> 1;
        for (var _loc5 = 0; _loc5 < _loc6; ++_loc5)
        {
            _loc2 = names[_loc5];
            if (_loc4[_loc2] == undefined)
            {
                _loc4[_loc2] = _loc2 == "commander" || _loc2 == "driver" ? (0) : (1);
            }
            else
            {
                _loc4[_loc2] = _loc4[_loc2] + 1;
            } // end else if
            var _loc3 = _loc4[_loc2] > 0 ? (_loc2 + _loc4[_loc2].toString()) : (_loc2);
            crewRenderers.push(this.createCrewRenderer("tankmen_" + _loc2, _loc3, _loc5));
            if (savedEntityMapping[_loc3] != undefined)
            {
                this.updateState(_loc3, savedEntityMapping[_loc3]);
                delete savedEntityMapping[_loc3];
            } // end if
        } // end of for
    } // End of the function
    function removeCrewRenderers(names)
    {
        while (crewRenderers.length > 0)
        {
            crewRenderers.pop().removeMovieClip();
        } // end while
    } // End of the function
    function createCrewRenderer(symbol, name, index)
    {
        entityMapping[name] = "crewContainer." + name;
        return (componentsContainer.crewContainer.attachMovie(symbol, name, componentsContainer.crewContainer.getNextHighestDepth(), {_x: (_crewItemWidth + _crewItemMargin) * index, _y: 0, toolTipData: "#ingame_gui:damage_panel/crew/" + name, crewName: name}));
    } // End of the function
    function showAll(isShow)
    {
        componentsContainer._visible = isShow;
    } // End of the function
    function ClearLogFlds()
    {
        TxtLog1.text = "";
        TxtLog2.text = "";
        TxtLog3.text = "";
        TxtLog4.text = "";
        TxtLog5.text = "";
        TxtLog6.text = "";
        TxtLog7.text = "";
        TxtLog8.text = "";
        TxtLog9.text = "";
        TxtLog10.text = "";
    } // End of the function
    function AddToLogFlds(iText)
    {
        TxtLog1.text = TxtLog2.text;
        TxtLog2.text = TxtLog3.text;
        TxtLog3.text = TxtLog4.text;
        TxtLog4.text = TxtLog5.text;
        TxtLog5.text = TxtLog6.text;
        TxtLog6.text = TxtLog7.text;
        TxtLog7.text = TxtLog8.text;
        TxtLog8.text = TxtLog9.text;
        TxtLog9.text = TxtLog10.text;
        TxtLog10.text = iText;
    } // End of the function
    var _maxHealth = 0;
    var _deviceNames = ["engine", "ammoBay", "gun", "turretRotator", "leftTrack", "rightTrack", "surveyingDevice", "radio", "fuelTank"];
    var crewRenderers = [];
    var cruiseCtrlModeTable = [3, 4, 5, 6, 2, 1];
    var _crewItemMargin = 1;
    var _crewItemWidth = 24;
    var _crewTotalWidth = 284;
    var isLogEnabled = true;
    var isVehicleDestroyed = false;
    var _LogHelth = 0;
    var _LogNb = 1;
} // End of Class
